Index: anr/flow.fig
===================================================================
--- anr/flow.fig	(revision 226)
+++ anr/flow.fig	(revision 275)
@@ -10,138 +10,157 @@
 5 1 1 1 0 7 50 -1 -1 4.000 0 0 1 0 10197.794 13038.971 5400 2700 6750 2175 10650 1650
 	1 1 1.00 60.00 120.00
-5 1 1 1 0 7 50 -1 -1 4.000 0 0 1 0 10745.564 6247.984 8250 4050 9750 3075 10875 2925
+5 1 1 1 0 7 50 -1 -1 4.000 0 1 1 0 9321.785 786.427 8775 5100 10575 4950 12480 3775
 	1 1 1.00 60.00 120.00
-5 1 1 1 0 7 50 -1 -1 4.000 0 1 1 0 9862.500 2550.000 9375 4275 10350 4275 10950 3975
+5 1 1 1 0 7 50 -1 -1 4.000 0 1 1 0 9862.500 3019.022 9375 4275 10350 4275 11025 3700
 	1 1 1.00 60.00 120.00
-5 1 1 1 0 7 50 -1 -1 4.000 0 1 1 0 9315.226 707.707 8775 5100 10575 4950 12300 3975
+5 1 1 1 0 7 50 -1 -1 4.000 0 0 1 0 10747.705 6264.035 8160 4150 9750 3075 10875 2925
 	1 1 1.00 60.00 120.00
-5 1 0 2 0 7 50 -1 -1 0.000 0 1 1 0 8562.500 4437.500 8850 4950 9075 4725 9150 4425
-	1 1 2.00 60.00 120.00
-6 4275 2475 6675 4950
+6 10635 2310 12900 5185
+6 10800 2400 12690 4435
+6 10800 2400 11272 3999
+6 10879 2545 11194 3417
+4 1 0 50 -1 2 17 0.0000 4 205 173 11036 2763 P\001
+4 1 0 50 -1 2 17 0.0000 4 205 205 11036 2981 R\001
+4 1 0 50 -1 2 17 0.0000 4 205 236 11036 3199 O\001
+4 1 0 50 -1 2 17 0.0000 4 205 205 11035 3418 C\001
+-6
+2 2 0 2 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
+	 10879 2473 11194 2473 11194 3926 10879 3926 10879 2473
+-6
+6 11272 2400 11745 3999
+6 11351 2545 11666 3199
+4 1 0 50 -1 2 17 0.0000 4 205 205 11509 2763 R\001
+4 1 0 50 -1 2 17 0.0000 4 205 205 11509 2981 A\001
+4 1 0 50 -1 2 17 0.0000 4 205 268 11509 3199 M\001
+-6
+2 2 0 2 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
+	 11351 2473 11666 2473 11666 3926 11351 3926 11351 2473
+-6
+6 11745 2400 12217 3999
+2 2 0 2 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
+	 11824 2473 12139 2473 12139 3926 11824 3926 11824 2473
+4 1 0 50 -1 2 17 0.0000 4 205 110 11981 2763 I\001
+4 1 0 50 -1 2 17 0.0000 4 205 236 11981 2981 O\001
+-6
+6 12217 2400 12690 3999
+6 12296 2473 12611 3781
+4 1 0 50 -1 2 17 0.0000 4 205 173 12454 3127 P\001
+4 1 0 50 -1 2 17 0.0000 4 205 205 12454 3345 R\001
+4 1 0 50 -1 2 17 0.0000 4 205 236 12454 3563 O\001
+4 1 0 50 -1 2 17 0.0000 4 205 205 12453 3781 C\001
+4 1 0 50 -1 2 17 0.0000 4 205 236 12454 2909 O\001
+4 1 0 50 -1 2 17 0.0000 4 205 205 12454 2691 C\001
+-6
+2 2 0 2 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
+	 12296 2473 12611 2473 12611 3926 12296 3926 12296 2473
+-6
+6 10800 3999 12690 4435
+2 2 0 2 0 7 50 -1 -1 0.000 0 0 7 0 0 5
+	 10879 4072 12611 4072 12611 4362 10879 4362 10879 4072
+4 1 0 50 -1 2 17 0.0000 4 205 567 11745 4290 BUS\001
+-6
+-6
+2 1 1 2 0 7 50 -1 -1 6.000 0 0 -1 0 0 2
+	 10650 4575 12870 4555
 2 4 0 2 0 7 50 -1 -1 0.000 0 0 7 0 0 5
-	 6450 3375 4500 3375 4500 2700 6450 2700 6450 3375
+	 12885 5170 12885 2325 10650 2325 10650 5170 12885 5170
+4 1 0 50 -1 0 12 0.0000 4 195 2085 11790 5040 (bitstream or IP-XACT)\001
+4 1 0 50 -1 2 16 0.0000 4 195 495 11820 4815 SoC\001
+-6
+6 1665 3300 3315 6107
+6 1665 3300 3315 4275
 2 4 0 2 0 7 50 -1 -1 0.000 0 0 7 0 0 5
-	 6450 4725 4500 4725 4500 4050 6450 4050 6450 4725
+	 3240 4200 1740 4200 1740 3375 3240 3375 3240 4200
+4 0 0 50 -1 2 16 0.0000 4 195 585 2265 3750 HPC\001
+4 0 0 50 -1 2 16 0.0000 4 255 1335 1890 4050 application\001
+-6
+6 1725 5552 3255 6107
+2 4 0 2 0 7 50 -1 -1 0.000 0 0 7 0 0 5
+	 3240 6092 1740 6092 1740 5567 3240 5567 3240 6092
+4 1 0 50 -1 2 16 0.0000 4 195 1095 2490 5927 Function\001
+-6
+6 1665 4387 3315 5362
+2 4 0 2 0 7 50 -1 -1 0.000 0 0 7 0 0 5
+	 3240 5287 1740 5287 1740 4462 3240 4462 3240 5287
+4 0 0 50 -1 2 16 0.0000 4 195 1245 1965 4837 Embedded\001
+4 0 0 50 -1 2 16 0.0000 4 255 1335 1890 5137 application\001
+-6
+-6
+6 4275 2307 6675 4782
+2 4 0 2 0 7 50 -1 -1 0.000 0 0 7 0 0 5
+	 6450 3207 4500 3207 4500 2532 6450 2532 6450 3207
+2 4 0 2 0 7 50 -1 -1 0.000 0 0 7 0 0 5
+	 6450 4557 4500 4557 4500 3882 6450 3882 6450 4557
 2 1 0 2 0 7 50 -1 -1 0.000 0 0 -1 1 1 2
 	1 1 3.00 60.00 120.00
 	1 1 3.00 60.00 120.00
-	 5475 3375 5475 4050
+	 5475 3207 5475 3882
 2 4 0 2 0 7 50 -1 -1 0.000 0 0 7 0 0 5
-	 6600 4875 4350 4875 4350 2550 6600 2550 6600 4875
-4 0 0 50 -1 2 16 0.0000 4 255 1815 4650 3075 Application PC\001
-4 0 0 50 -1 2 16 0.0000 4 255 1950 4575 4425 Application SoC\001
+	 6600 4707 4350 4707 4350 2382 6600 2382 6600 4707
+4 0 0 50 -1 2 16 0.0000 4 255 1815 4650 2907 Application PC\001
+4 0 0 50 -1 2 16 0.0000 4 255 1950 4575 4257 Application SoC\001
 -6
-6 1725 3300 3375 4275
+6 10950 300 12225 900
+4 0 0 50 -1 2 16 0.0000 4 255 1395 10950 525 Application\001
+4 0 0 50 -1 2 16 0.0000 4 255 1425 10950 825 compilation\001
+-6
+6 7575 3975 9675 6000
+5 1 0 2 0 7 50 -1 -1 0.000 0 1 1 0 8562.500 4587.500 8850 5100 9075 4875 9150 4575
+	1 1 2.00 60.00 120.00
+1 4 0 2 0 7 50 -1 -1 0.000 1 0.0000 8595 5177 228 228 8367 5177 8823 5177
+1 4 0 2 0 7 50 -1 -1 0.000 1 0.0000 8103 4350 228 228 7875 4350 8331 4350
+1 4 0 2 0 7 50 -1 -1 0.000 1 0.0000 9118 4363 228 228 8890 4363 9346 4363
+2 1 0 2 0 7 50 -1 -1 0.000 0 0 -1 1 0 2
+	1 1 2.00 60.00 120.00
+	 8925 4350 8325 4350
 2 4 0 2 0 7 50 -1 -1 0.000 0 0 7 0 0 5
-	 3300 4200 1800 4200 1800 3375 3300 3375 3300 4200
-4 0 0 50 -1 2 16 0.0000 4 195 585 2325 3750 HPC\001
-4 0 0 50 -1 2 16 0.0000 4 255 1335 1950 4050 application\001
+	 9600 5925 7650 5925 7650 4050 9600 4050 9600 5925
+2 1 1 2 0 7 50 -1 -1 4.000 0 0 -1 0 0 2
+	 7650 5475 9600 5475
+4 0 0 50 -1 2 12 0.0000 4 150 240 8475 5250 T0\001
+4 0 0 50 -1 2 12 0.0000 4 150 240 8025 4425 T1\001
+4 0 0 50 -1 2 12 0.0000 4 150 240 9000 4425 T2\001
+4 0 0 50 -1 2 16 0.0000 4 195 1905 7725 5775 Process network\001
 -6
-6 7500 975 9750 3675
-6 7725 1125 9525 3225
-6 7725 1125 8175 2775
-6 7800 1275 8100 2175
-4 1 0 50 -1 2 16 0.0000 4 195 165 7950 1500 P\001
-4 1 0 50 -1 2 16 0.0000 4 195 195 7950 1725 R\001
-4 1 0 50 -1 2 16 0.0000 4 195 225 7950 1950 O\001
-4 1 0 50 -1 2 16 0.0000 4 195 195 7949 2175 C\001
+6 7560 885 9690 3765
+6 7725 975 9525 3075
+6 7725 975 8175 2625
+6 7800 1125 8100 2025
+4 1 0 50 -1 2 16 0.0000 4 195 165 7950 1350 P\001
+4 1 0 50 -1 2 16 0.0000 4 195 195 7950 1575 R\001
+4 1 0 50 -1 2 16 0.0000 4 195 225 7950 1800 O\001
+4 1 0 50 -1 2 16 0.0000 4 195 195 7949 2025 C\001
 -6
 2 2 0 2 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
-	 7800 1200 8100 1200 8100 2700 7800 2700 7800 1200
+	 7800 1050 8100 1050 8100 2550 7800 2550 7800 1050
 -6
-6 8175 1125 8625 2775
-6 8250 1275 8550 1950
-4 1 0 50 -1 2 16 0.0000 4 195 195 8400 1500 R\001
-4 1 0 50 -1 2 16 0.0000 4 195 195 8400 1725 A\001
-4 1 0 50 -1 2 16 0.0000 4 195 255 8400 1950 M\001
+6 8175 975 8625 2625
+6 8250 1125 8550 1800
+4 1 0 50 -1 2 16 0.0000 4 195 195 8400 1350 R\001
+4 1 0 50 -1 2 16 0.0000 4 195 195 8400 1575 A\001
+4 1 0 50 -1 2 16 0.0000 4 195 255 8400 1800 M\001
 -6
 2 2 0 2 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
-	 8250 1200 8550 1200 8550 2700 8250 2700 8250 1200
+	 8250 1050 8550 1050 8550 2550 8250 2550 8250 1050
 -6
-6 8625 1125 9075 2775
+6 8625 975 9075 2625
 2 2 0 2 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
-	 8700 1200 9000 1200 9000 2700 8700 2700 8700 1200
-4 1 0 50 -1 2 16 0.0000 4 195 105 8850 1500 I\001
-4 1 0 50 -1 2 16 0.0000 4 195 225 8850 1725 O\001
+	 8700 1050 9000 1050 9000 2550 8700 2550 8700 1050
+4 1 0 50 -1 2 16 0.0000 4 195 105 8850 1350 I\001
+4 1 0 50 -1 2 16 0.0000 4 195 225 8850 1575 O\001
 -6
-6 7725 2775 9525 3225
+6 7725 2625 9525 3075
 2 2 0 2 0 7 50 -1 -1 0.000 0 0 7 0 0 5
-	 7800 2850 9450 2850 9450 3150 7800 3150 7800 2850
-4 1 0 50 -1 2 16 0.0000 4 195 540 8625 3075 BUS\001
+	 7800 2700 9450 2700 9450 3000 7800 3000 7800 2700
+4 1 0 50 -1 2 16 0.0000 4 195 540 8625 2925 BUS\001
 -6
 -6
+2 1 1 2 0 7 50 -1 -1 6.000 0 0 -1 0 0 2
+	 7575 3150 9675 3150
 2 4 0 2 0 7 50 -1 -1 0.000 0 0 7 0 0 5
-	 9675 3600 9675 1050 7575 1050 7575 3600 9675 3600
-2 1 1 2 0 7 50 -1 -1 6.000 0 0 -1 0 0 2
-	 7575 3300 9675 3300
-4 1 0 50 -1 2 16 0.0000 4 195 1080 8625 3525 Platform\001
+	 9675 3750 9675 900 7575 900 7575 3750 9675 3750
+4 1 0 50 -1 2 16 0.0000 4 195 1635 8625 3375 Architectural\001
+4 1 0 50 -1 2 16 0.0000 4 255 1140 8625 3630 Template\001
 -6
-6 10575 2250 12825 4950
-6 10800 2400 12600 4500
-6 10800 2400 11250 4050
-6 10875 2550 11175 3450
-4 1 0 50 -1 2 16 0.0000 4 195 165 11025 2775 P\001
-4 1 0 50 -1 2 16 0.0000 4 195 195 11025 3000 R\001
-4 1 0 50 -1 2 16 0.0000 4 195 225 11025 3225 O\001
-4 1 0 50 -1 2 16 0.0000 4 195 195 11024 3450 C\001
--6
-2 2 0 2 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
-	 10875 2475 11175 2475 11175 3975 10875 3975 10875 2475
--6
-6 11250 2400 11700 4050
-6 11325 2550 11625 3225
-4 1 0 50 -1 2 16 0.0000 4 195 195 11475 2775 R\001
-4 1 0 50 -1 2 16 0.0000 4 195 195 11475 3000 A\001
-4 1 0 50 -1 2 16 0.0000 4 195 255 11475 3225 M\001
--6
-2 2 0 2 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
-	 11325 2475 11625 2475 11625 3975 11325 3975 11325 2475
--6
-6 11700 2400 12150 4050
-2 2 0 2 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
-	 11775 2475 12075 2475 12075 3975 11775 3975 11775 2475
-4 1 0 50 -1 2 16 0.0000 4 195 105 11925 2775 I\001
-4 1 0 50 -1 2 16 0.0000 4 195 225 11925 3000 O\001
--6
-6 12150 2400 12600 4050
-6 12225 2475 12525 3825
-4 1 0 50 -1 2 16 0.0000 4 195 165 12375 3150 P\001
-4 1 0 50 -1 2 16 0.0000 4 195 195 12375 3375 R\001
-4 1 0 50 -1 2 16 0.0000 4 195 225 12375 3600 O\001
-4 1 0 50 -1 2 16 0.0000 4 195 195 12374 3825 C\001
-4 1 0 50 -1 2 16 0.0000 4 195 225 12375 2925 O\001
-4 1 0 50 -1 2 16 0.0000 4 195 195 12375 2700 C\001
--6
-2 2 0 2 0 7 50 -1 -1 0.000 0 0 -1 0 0 5
-	 12225 2475 12525 2475 12525 3975 12225 3975 12225 2475
--6
-6 10800 4050 12600 4500
-2 2 0 2 0 7 50 -1 -1 0.000 0 0 7 0 0 5
-	 10875 4125 12525 4125 12525 4425 10875 4425 10875 4125
-4 1 0 50 -1 2 16 0.0000 4 195 540 11700 4350 BUS\001
--6
--6
-2 4 0 2 0 7 50 -1 -1 0.000 0 0 7 0 0 5
-	 12750 4875 12750 2325 10650 2325 10650 4875 12750 4875
-2 1 1 2 0 7 50 -1 -1 6.000 0 0 -1 0 0 2
-	 10650 4575 12750 4575
-4 1 0 50 -1 2 16 0.0000 4 195 1080 11700 4800 Platform\001
--6
-6 11100 300 12375 900
-4 0 0 50 -1 2 16 0.0000 4 255 1395 11100 525 Application\001
-4 0 0 50 -1 2 16 0.0000 4 255 1425 11100 825 compilation\001
--6
-6 1725 4650 3375 5625
-2 4 0 2 0 7 50 -1 -1 0.000 0 0 7 0 0 5
-	 3300 5550 1800 5550 1800 4725 3300 4725 3300 5550
-4 0 0 50 -1 2 16 0.0000 4 195 1245 2025 5100 Embedded\001
-4 0 0 50 -1 2 16 0.0000 4 255 1335 1950 5400 application\001
--6
-1 4 0 2 0 7 50 -1 -1 0.000 1 0.0000 8595 5027 228 228 8367 5027 8823 5027
-1 4 0 2 0 7 50 -1 -1 0.000 1 0.0000 8103 4200 228 228 7875 4200 8331 4200
-1 4 0 2 0 7 50 -1 -1 0.000 1 0.0000 9118 4213 228 228 8890 4213 9346 4213
-2 1 0 2 0 7 50 -1 -1 0.000 0 0 -1 1 0 2
-	1 1 2.00 60.00 120.00
-	 6600 4425 7650 4425
 2 1 0 2 0 7 50 -1 -1 0.000 0 0 -1 1 0 2
 	1 1 2.00 60.00 120.00
@@ -151,36 +170,21 @@
 2 1 1 2 0 7 50 -1 -1 4.000 0 0 -1 0 0 2
 	 10125 150 10125 6450
-2 1 0 2 0 7 50 -1 -1 0.000 0 0 -1 0 1 2
-	1 1 2.00 60.00 120.00
-	 5475 6450 5475 4875
-2 1 0 2 0 7 50 -1 -1 0.000 0 0 -1 0 1 2
-	1 1 2.00 60.00 120.00
-	 11700 6450 11700 4875
-2 4 0 2 0 7 50 -1 -1 0.000 0 0 7 0 0 5
-	 12750 1950 10650 1950 10650 1275 12750 1275 12750 1950
 2 1 1 2 0 7 50 -1 -1 4.000 0 0 -1 0 0 2
 	 3750 150 3750 6450
 2 1 0 2 0 7 50 -1 -1 0.000 0 0 -1 1 0 2
 	1 1 2.00 60.00 120.00
-	 3300 5175 7650 5175
+	 6375 4275 7650 4262
 2 1 0 2 0 7 50 -1 -1 0.000 0 0 -1 1 0 2
 	1 1 2.00 60.00 120.00
-	 8925 4200 8325 4200
-2 1 0 2 0 7 50 -1 -1 0.000 0 0 -1 0 1 2
-	1 1 2.00 60.00 120.00
-	 8550 6450 8550 5775
+	 3300 4962 7650 4962
+2 1 0 2 0 7 50 -1 -1 0.000 0 0 -1 0 0 3
+	 3225 5850 4725 5850 4725 4950
 2 4 0 2 0 7 50 -1 -1 0.000 0 0 7 0 0 5
-	 9600 5775 7650 5775 7650 3900 9600 3900 9600 5775
-2 1 1 2 0 7 50 -1 -1 4.000 0 0 -1 0 0 2
-	 7650 5325 9600 5325
+	 12855 1960 10650 1960 10650 1275 12855 1275 12855 1960
 4 0 0 50 -1 2 16 0.0000 4 195 1305 11100 1650 Executable\001
-4 0 0 50 -1 2 16 0.0000 4 255 1065 11250 6750 Running\001
 4 0 0 50 -1 2 16 0.0000 4 255 690 2250 675 Input\001
 4 0 0 50 -1 2 16 0.0000 4 255 1290 4800 675 HPC setup\001
 4 0 0 50 -1 2 16 0.0000 4 255 1305 8025 675 SoC design\001
-4 0 0 50 -1 2 12 0.0000 4 150 240 8475 5100 T0\001
-4 0 0 50 -1 2 12 0.0000 4 150 240 8025 4275 T1\001
-4 0 0 50 -1 2 12 0.0000 4 150 240 9000 4275 T2\001
-4 0 0 50 -1 2 16 0.0000 4 195 1905 7725 5625 Process network\001
-4 0 0 50 -1 2 16 0.0000 4 255 2535 4200 6750 Performance analysis\001
-4 0 0 50 -1 2 16 0.0000 4 255 2535 7350 6750 Performance analysis\001
+4 0 0 50 -1 2 16 0.0000 4 255 2535 7350 6300 Performance analysis\001
+4 0 0 50 -1 2 16 0.0000 4 255 2535 4275 6300 Performance analysis\001
+4 0 0 50 -1 2 16 0.0000 4 255 2805 10350 6300 Running or Integration\001